#include <malloc.h>
void insline();
void pageup();
void pagedown();
void text_color();
void draw_border();
void initilisecol();
line *getline();
node *getnode();
void insnode(char c);
void delkey();
void backspace();
void display(int flag);

void insline()
{
    int tc;
    tc = count;
    count = 1;
    insnode('\n');
    count = tc;
    if (y == ybottom)
    {
	 if ((topnode -> count % max == 0) && (topnode -> count != 0))
	      y -= topnode -> count / max - 1;
	 else
	      y -= topnode -> count / max;
	 topnode = topnode -> down;
	 display(1);
    }
    else
	 y++;
    lines++;
    display(1);
}

void pageup()
{
   line *tl,*nl,*tn;
   int i;
   if (curline == s || s == NULL)
   {
       beep();
       return;
   }
   tl = curline;
   i = 1;
   keyhome();
   while (i <= 20)
   {
       if (tl -> up)
	   tl = tl -> up;
       else
	   break;
       if (((tl -> count % max) == 0) && (tl -> count != 0))
	   i += tl -> count /max;
       else
	   i += tl -> count /max + 1;
   }
   i--;
   topnode = tl;
   curline = topnode;
   x = 1;
   y = ytop;
   count = 1;
   display(1);
   lines -= i;
   dispnum(1);
}

void pagedown()
{
   line *tl,*nl,*tn;
   int i;
   if (curline)
   {
       if (s == NULL || curline -> down == NULL)
       {
	      beep();
	      return;
       }
   }
   else
   {
	      beep();
	      return;
   }
   tl = curline;
   i = 0;
   keyhome();
   while (i < 20)
   {
       if ( ((tl -> count % max) == 0) && (tl -> count != 0))
		i += (tl -> count) /max;
       else
		i += (tl -> count) /max + 1;
       if (tl -> down)
       {
	   tl = tl -> down;
	   if (tl -> down == NULL)
	      break;
       }
       else
	   break;
   }
   topnode = tl;
   curline = topnode;
   x = 1;
   y = ytop;
   count = 1;
   display(1);
   lines += i;
   dispnum(1);
}

void text_color()
{
    void *p = NULL;
    if(bk == 1)
    {
	if((textcolor+7)!=10)
	{
	     color_set(textcolor+7,p);
	     wcolor_set(textwin,textcolor+7,p);
	}
	else
	{
	     beep();
	     return;
	}
    }
    else
    {
	color_set(textcolor,p);
	wcolor_set(textwin,textcolor,p);
    }
    //wrefresh(textwin);
    refresh();
}

void draw_border()
{
    void *p = NULL;
    if (bk)
    {
	bkgd(COLOR_PAIR(8));
	wbkgd(textwin,COLOR_PAIR(8));
	color_set(bordercolor + 7,p);
	wcolor_set(textwin,bordercolor + 7,p);
    }
    else
    {
	bkgd(COLOR_PAIR(1));
	wbkgd(textwin,COLOR_PAIR(1));
	color_set(bordercolor,p);
	wcolor_set(textwin,bordercolor + 7,p);
    }
    box (stdscr,ACS_VLINE,ACS_HLINE);
    wrefresh(textwin);
    refresh();
}

void initialisecol()
{
       start_color();
       init_pair (1,COLOR_WHITE,COLOR_BLACK);
       init_pair (2,COLOR_GREEN,COLOR_BLACK);
       init_pair (3,COLOR_BLUE,COLOR_BLACK);
       init_pair (4,COLOR_RED,COLOR_BLACK);
       init_pair (5,COLOR_MAGENTA,COLOR_BLACK);
       init_pair (6,COLOR_CYAN,COLOR_BLACK);
       init_pair (7,COLOR_YELLOW,COLOR_BLACK);
       init_pair (8,COLOR_WHITE,COLOR_BLUE);
       init_pair (9,COLOR_GREEN,COLOR_BLUE);
       init_pair (10,COLOR_BLUE,COLOR_BLUE);
       init_pair (11,COLOR_RED,COLOR_BLUE);
       init_pair (12,COLOR_MAGENTA,COLOR_BLUE);
       init_pair (13,COLOR_CYAN,COLOR_BLUE);
       init_pair (14,COLOR_YELLOW,COLOR_BLUE);
       init_pair (15,COLOR_BLACK,COLOR_BLACK);
       init_pair (16,COLOR_BLUE,COLOR_WHITE);
       init_pair (18,COLOR_RED,COLOR_GREEN);
       init_pair (31,COLOR_BLUE,COLOR_WHITE);
       init_pair (19,COLOR_RED,COLOR_WHITE);
}

line *getline()
{
    line *t;
    t = (line*) malloc (sizeof(line));
    if (t == NULL)
    {
	waddstr (stdscr," OUT OF MEMORY ");
	quit();
    }
    else
    {
	t -> count = 0; // Initially there are 0 characters in the line
	t -> up = NULL;
	t -> down = NULL;
	t -> start = NULL;
	return (t);
     }
}

node *getnode()
{
    node *t;
    t = (node*) malloc(sizeof (node));
    if (t == NULL)
    {
	waddstr (stdscr," OUT OF MEMORY ");
	quit();
    }
    else
    {
	t -> next = NULL;
	return (t);
    }
}

void insnode(char c)
{
    line *tl,*nl;
    node *n,*t,*p;
    int i;

    if (c == '\n')
    {
	nl = getline();         // if newline create newline
	if (s == NULL)
	{
		curline = getline();
		nl -> down = curline;
		curline -> up = nl;
		s = nl;
		topnode = nl;
	}
	else
	{
		if (count > curline -> count) // If enter key at the end of line
		{
			nl -> up = curline;
			nl -> down = curline -> down;
			if (curline -> down != NULL)
				curline -> down -> up = nl;
			curline -> down = nl;
			curline = nl;
		}
		else // If enter key is not at the end of the line
		{
			t = curline -> start;
			p = t;
			i = count;
			while(i-1)
			{
				p = t;
				t = t -> next;
				i--;
			}
			if (count == 1) // If enter key at beginning of line
			{
				nl -> start = curline -> start;
				curline -> start = NULL;
				nl -> count = curline -> count;
				curline -> count = 0;
			}
			else // If enter key at end of line
			{
				nl -> start = p -> next;
				p -> next = NULL;
				nl -> count = curline -> count - count + 1;
				curline -> count = count - 1;
			}
			nl -> up = curline;
			nl -> down = curline -> down;
			if (curline -> down != NULL)
			      curline -> down -> up = nl;
			curline -> down = nl;
			curline = nl;
		}
	}
    }
    else
    {
	n = getnode(); // Create a node to store the character
	n -> item = c;
	if (s == NULL)
	{
		nl = getline(); // If no line is created create line
		s = nl;
		curline = nl;
		nl -> start = n;
		curline -> count++;
		topnode = nl;
	}
	else
	{
		if (curline -> start == NULL) // If it is the first character in the line
			curline -> start = n;
		else // If it not the first character
		{
			t = curline -> start;
			p = t;
			i = count ; // Move to the count to insert the node
			while (i -1)
			{
				p = t;
				t  = t -> next;
				i--;
			}
			if (count == 1) // If first position
			{
				n -> next = curline -> start;
				curline -> start = n;
			}
			else
			{
				p -> next = n;
				n -> next = t;
			}
		}
		curline -> count++;
	}
    }
}

void delkey()
{
    node *t,*p;
    line *nl,*nnl;
    int i;

    if (curline == NULL)
    {
	beep();
	return;
    }

    if (count > curline -> count )
    {
	 nl = curline -> down;
	 if (!nl)
	 {
	      beep();
	      return;
	 }
	 t = curline -> start;
	 if (t)
	     while (t -> next)
		 t = t -> next;
	 if (t)
	     t -> next = nl -> start;
	 else
	     curline -> start = nl -> start;

	 curline ->count += nl -> count;


	 if (nl -> down)
	 {
	     nnl = nl -> down;
	     curline -> down = nnl;
	     if (nnl -> up)
		 nnl -> up = curline;
	 }
	 else
	     curline -> down = NULL;
	display(1);
	return;
    }
    else
    if (count == 1)
    {
	curline -> start = curline -> start -> next;
	curline -> count --;
    }
    else
    {
	t = curline -> start;
	i = count;
	while (i - 1)
	{
	    p = t;
	    t = t -> next;
	    i--;
	}

	p -> next = t -> next;
	curline -> count--;
    }
    display (1);
}

void backspace()
{
    node *t,*p;
    line *pl,*nl;
    int i,j;
    if (count % max == 1) // If cursor is at the xleft position
    {
	if ((curline -> count >= max) && count != 1) // If line is displayed as more than 1 line
	{
	    t = curline -> start;
	    i = (curline -> count / max) * max;
	    while (i-1)
	    {
		p = t;
		t = t -> next;
		i--;
	    }
	    p -> next = t -> next;
	    curline -> count --;
	    count --;
	    if (x == 1)
		y--;
	    x = max;
	}
	else
	{
	    if (curline == s)
	    {
		beep();
		return;
	    }
	    pl = curline -> up;
	    nl = curline -> down;
	    t = pl -> start;
	    if (t)
		while (t -> next)
			t = t -> next;
	    if (t)
		t -> next = curline -> start;
	    else
		pl -> start = curline -> start;

	    pl -> down = nl;
	    if (nl)
		nl -> up = pl;
	    if (pl -> count % max == 0 && pl -> count != 0)
		x = max;
	    else
		x = pl -> count % max + 1;
	    if ((pl -> count % max == 0) && (pl -> count != 0))
		 count = ((pl -> count - 1) / max * max) + x + 1;
	    else
		 count = (pl -> count / max * max ) + x;
	    pl -> count = pl -> count + curline -> count;
	    free(curline);
	    if (curline == topnode)
		topnode = pl;
	    curline = pl;
	    if (y > ytop)
		y--;
	    else
	    {
		display(1);
		if ((topnode -> count % max == 0) && (topnode -> count != 0))
		    y += topnode -> count / max - 1;
		else
		    y += topnode -> count / max;
	    }
	}
	lines--;
	display(1);
	return;
    }
    else
    if (count == 2)
    {
	if (curline -> start -> next)
		curline -> start = curline -> start -> next;
	else
		curline -> start = NULL;
	curline -> count --;
	count--;
    }
    else
    {
	t = curline -> start;
	i = count;
	while (i - 2)
	{
	    p = t;
	    t = t -> next;
	    i--;
	}

	p -> next = t -> next;
	curline -> count--;
	count--;
    }
    x--;
    i = curline -> count + 1;
    j = y;
    while (i)
    {
       wmove (textwin,j,i);
       waddch(textwin,' ');
       i--;
    }
    if (curline -> count >= max)
	display(1);
    else
	display(0);
}

void display(int flag)
{
  line *t1;
  node *tn;
  int i,j;
  if(flag)
  {
	wclear (textwin);
	t1 = topnode;
	i = 0;
	j = ytop;
	while(t1)
	{
		tn = t1 -> start;
		while(tn)
		{
			if ((i == (max - 1)) && (j == ybottom))
			     break;
			if(i == max)
			{
				i=1;
				j++;
				if (j > ybottom)
				    break;
			}
			else
				i++;
			wmove (textwin,j,i);
			waddch(textwin,(tn -> item));
			tn = tn -> next;
		}
		i = 0;
		t1 = t1 -> down;
		j++;
		if(j > ybottom)
			break;
	}
   }
   else
   {
	tn=curline->start;
	if (count % max == 0)
	     for (i=1 ; i <= max * ((int)(count/max) - 1);i++)
		  tn = tn -> next;
	else
	     for (i=1 ; i <= (max * (int)(count/max));i++)
		  tn = tn -> next;
	i = 0;
	j=y;
	while(tn)
	{
		if (i == max)
		{
			i = 1;
			j++;
		}
		else
			i++;
		wmove (textwin,j,i);
		waddch(textwin,(tn->item));
		tn = tn->next;
	}
    }
    wmove(textwin,y,x);
    wrefresh(textwin);
}

