void keyhome();
void keyend();
void help(int y);
void textcol(int f);
int movement(char *s[],int num,int width,int xpos);
void wordcount();
int savefile(int ch);
void dispsflag();
void fileoption(int o);
void setmargin();
void search();
void filemenu();
void editmenu();
void settings();
void helpmenu();

void keyhome()
{
    if (curline == NULL || count == 1) // If no characters in the line or
	return;
    if (count % max == 0)
    {
	y = y - count / max + 1;
	lines = lines - count / max + 1;
    }
    else
    {
	y = y - count / max;
	lines = lines - count / max;
    }
    if (count % max == 1 && count != 1 && x == max)
    {
	lines++;
	y++;
    }
    count = 1;
    x = 1;
    dispnum(1);
}

void keyend()
{
    if (curline == NULL || count == curline -> count + 1)
	return;
    if (y == ybottom && curline -> count >= max)
    {
	beep();
	return;
    }
    if (curline -> count % max == 0)
	x = max;
    else
	x = curline -> count % max + 1;

    if (curline -> count % max != 0)
    {
	if (curline -> count / max != count / max)
	{
	    y = y + curline -> count /max - count /max;
	    lines = lines + curline -> count /max - count /max;
	}
	else
	{
	    y += (curline -> count - count) / max ;
	    lines += (curline -> count - count) / max ;
	}
    }
    else
    {
	if (curline -> count / max - 1 != count / max)
	{
	    y = y + curline -> count / max  - 1 - count /max;
	    lines = lines + curline -> count / max  - 1 - count /max;
	}
	else
	{
	    y += (curline -> count - count)/ max ;
	    lines += (curline -> count - count)/ max ;
	}
    }
    count = curline -> count + 1;
    dispnum(1);
}

void help(int y)
{
   WINDOW  *i,*t;
   int f;
   chtype c;
   curs_set(0);
   switch(y)
   {
       case 3:
	   i=newwin(19,50,3,18);
	   wbkgd(i,COLOR_PAIR(31));
	   wattron(i,COLOR_PAIR(16));
	   box(i,ACS_VLINE,ACS_HLINE);
	   wmove(i,1,20);
	   waddstr(i,"HELP MENU");
	   wmove(i,3,4);
	   waddstr(i,"    COMMANDS                     HOT KEYS  ");
	   wmove(i,5,4);
	   waddstr(i,"       F1                            Help  ");
	   wmove(i,6,4);
	   waddstr(i,"       F2                            Save  ");
	   wmove(i,7,4);
	   waddstr(i,"       F3                            Open  ");
	   wmove(i,8,4);
	   waddstr(i,"     Ctrl+F                     File Menu  ");
	   wmove(i,9,4);
	   waddstr(i,"     Ctrl+E                     Edit Menu  ");
	   wmove(i,10,4);
	   waddstr(i,"     Ctrl+T                 Settings Menu  ");
	   wmove(i,11,4);
	   waddstr(i,"     Ctrl+H                     Help Menu  ");
	   wmove(i,12,4);
	   waddstr(i,"     Ctrl+N              Creates New File  ");
	   wmove(i,13,4);
	   waddstr(i,"     Ctrl+X               Quit The Editor  ");
	   wmove(i,14,4);
	   waddstr(i,"     Ctrl+X               Quit The Editor  ");
	   wmove(i,15,4);
	   waddstr(i,"     Ctrl+W                   Delete Word  ");
	   wmove(i,16,4);
	   waddstr(i,"     Ctrl+Y                   Delete Line  ");
	   wmove(i,17,4);
	   waddstr(i,"     Ctrl+L                   Insert Line  ");
	   wrefresh(i);
	   getch();
	   delwin(i);
	   break;
       case 2:
	   t=newwin(13,27,3,28);
	   wbkgd(t,COLOR_PAIR(31));
	   wattron(t,COLOR_PAIR(16));
	   box(t,ACS_VLINE,ACS_HLINE);
	   wmove(t,1,8);
	   waddstr(t," TEXT EDTIOR ");
	   wmove(t,3,2);
	   waddstr(t," Designed By ");
	   wmove(t,5,7);
	   waddstr(t,"Arun Singh K ");
	   wmove(t,7,6);
	   waddstr(t, " Karthik B .V ");
	   wmove(t,9,1);
	   waddstr(t," FIFTH SEMESTER  CSE");
	   wmove(t,10,6);
	   waddstr(t," A.P.S.C.E ");
	   wrefresh(t);
	   getch();
	   delwin(t);
	   break;
   }
   curs_set(1);
   touchwin(stdscr);
   refresh();
   touchwin(textwin);
   wrefresh(textwin);
   display(1);
}

void textcol(int f)
{     
      WINDOW *wi;     
      chtype c;
      chtype col; 

      char *colour[] = {  " White   ",
			  " Green   ",
		          " Blue    ",
                          " Red     ",
                          " Magenta ",
                          " Cyan    ",
                          " Yellow  " };

      switch(f)
       {

	       case 0:
	       case 1:
		       wi= newwin(12,25,9,27);
		       wbkgd(wi,COLOR_PAIR(31));
		       wmove(wi,10,16);
                       wattron(wi,COLOR_PAIR(19));
		       box( wi,ACS_VLINE,ACS_HLINE);
		       wmove(wi,1,1);
		       waddstr(wi,"Select colour");
		       for(col=0;col<7;col++)
		       {
			   wmove(wi,col+3,1);
			   wprintw(wi,"%d  %s",col+1,colour[col]);
		       }
		       wmove(wi,10,1);
		       echo();
		       waddstr(wi,"Enter the no");
		       wrefresh(wi);
		       while(1)
		       {
			   wmove(wi,10,14);
			   waddstr(wi,"      ");
			   col = wgetch(wi);
                           if((col > '0' && col < '8' ) || col == 27)
			   break;
		       }
		       noecho();
		       delwin(wi);
		       touchwin(stdscr);
		       refresh();
		       if(col == 27)
		           break;
		       if(f == 0)
		       {
			  textcolor = col - '0';
			  text_color();
		       }
		       else
			 {
			    bordercolor=col - '0';
			    draw_border();
	                    init();
			    text_color();
			 }
		       break;

	       case 2:
		       wi= newwin(9,28,10,27);
		       wbkgd(wi,COLOR_PAIR(31));
                       wattron(wi,COLOR_PAIR(19));
		       box( wi,ACS_VLINE,ACS_HLINE);
		       wmove(wi,1,1);
		       waddstr(wi,"select colour");
		       wmove(wi,3,1);
		       waddstr(wi,"Options");
		       wmove(wi,4,1);
		       waddstr(wi," 1 Black ");
		       wmove(wi,5,1);
		       waddstr(wi," 2 Blue ");
		       wmove(wi,6,1);
		       waddstr(wi," Enter the colour no ");
		       wrefresh(wi);
		       echo();
		       while(1)
		       {
			   wmove(wi,6,21);
			   waddstr(wi,"   ");
			   wrefresh(wi);
			   col = wgetch(wi);
			   if(col == '2' || col == '1' || col == 27)
			       break;
		       }
		      noecho();
		      delwin(wi);
		      touchwin(stdscr);
		      refresh();
		      if(col == 27)
			   break;
		      bk = col - '0' - 1;
		      draw_border();
	              init();
		      text_color();
		      break;
	   }
	display(1);
	dispnum(2);
	dispsflag();
}

int movement(char *s[],int num,int width,int xpos)
{
    WINDOW *w = newwin (num+2,width,2,xpos);
    chtype ch;
    void *p;
    int i,ret;
    bool flag=0;

    wattron (w,COLOR_PAIR(16));
    box (w,ACS_VLINE,ACS_HLINE);
    for (i=1;i<=num;i++)
    {
	wmove (w,i,1);
	waddstr (w,s[i-1]);
    }
    curs_set(0);
    i = 1;
    wrefresh(w);
    keypad(w,1);
    wmove (w,1,1);
    wattr_on (w,A_STANDOUT,p);
    waddstr (w,s[0]);
    wrefresh(w);
    flag = 0;
    while (1)
    {
	if (flag)
	    break;
	ch = getch();
	if (ch == 27)
	{
	    ret = 10;
	    break;
	}
	if (ch  == '\n')
	{
	    ret = i - 1;
	    break;
	}
	switch(ch)
	{
		case KEY_UP:
				wattr_off(w,A_STANDOUT,p);
				wmove (w,i,1);
				waddstr (w,s[i-1]);
				if ( i == 1)
					i = num;
				else
					i--;
				wmove (w,i,1);
				wattr_on (w,A_STANDOUT,p);
				waddstr (w,s[i-1]);
				wrefresh (w);
				break;
		case KEY_DOWN:
				wattr_off(w,A_STANDOUT,p);
				wmove (w,i,1);
				waddstr (w,s[i-1]);
				if ( i == num)
					i = 1;
				else
					i++;
				wmove (w,i,1);
				wattr_on (w,A_STANDOUT,p);
				waddstr (w,s[i-1]);
				wrefresh (w);
				break;
		case KEY_LEFT:
				ret = -1;
				flag=1;
				break;
		case KEY_RIGHT:
				ret = -2;
				flag=1;
				break;
	}
     }
     curs_set(1);
     wclear(w);
     wrefresh(w);
     delwin(w);
     touchwin(stdscr);
     refresh();
     display(1);
     wrefresh(textwin);
     return ret;
}

void wordcount()
{
   line *tl;
   node *t;
   int lines=0,chars=0,words=0,spaces=0;
   bool flag=0;
   WINDOW *w;
   if (s == NULL)
   {
       beep();
       return;
   }

   tl = s;
   while (tl)
   {
       t = tl -> start;
       while (t)
       {
	   if (flag && t -> item == ' ')
	   {
	       words++;
	       flag = 0;
	   }
	   if (t -> item == ' ')
	       spaces++;
	   else
	   {
	       chars++;
	       flag = 1;
	   }
	   t = t -> next;
       }
       if (flag)
       {
	   flag = 0;
	   words++;
       }
       lines++;
       tl = tl -> down;
   }
   w = msgbox(8,40,9,20);
   wmove (w,1,1);
   waddstr (w,"Word Count");
   wmove (w,3,2);
   waddstr (w,"Characters without Blanks : ");
   wprintw(w,"%d",chars);
   wmove (w,4,2);
   waddstr (w,"Blanks : ");
   wprintw(w,"%d",spaces);
   wmove (w,5,2);
   waddstr (w,"Words : ");
   wprintw(w,"%d",words);
   wmove (w,6,2);
   waddstr (w,"Lines : ");
   wprintw(w,"%d",lines);
   wrefresh(w);
   curs_set(0);
   wgetch(w);
   curs_set(1);
   delwin(w);
   touchwin(stdscr);
   refresh();
   touchwin(textwin);
   wrefresh(textwin);
}

int savefile(int ch)
{
   WINDOW *w,*n;
   chtype c;
   char name[30];
   int i=0;
   FILE *fp;
   line *tl;
   node *t;

   if (ch == 1) // To give the warning and ask for saving
   {
       w = msgbox(8,40,9,20);
       wmove (w,1,1);
       waddstr (w,"Warning");
       wmove (w,4,1);
       waddstr (w," File : ");
       waddstr (w,fname);
       wmove (w,6,5);
       waddstr (w," Not saved Save(Y/N) : ");
       while (1)
       {
	   c = wgetch(w);
	   if (c == 27)
	   {
	       ch = 5;
	       break;
	   }
	   if (c == 'y' || c == 'Y')
	   {
	       if (strcmp(fname,"Untitled") == 0)
		   ch = 2;
	       else
		   ch = 3;
	       break;
	   }
	   if (c == 'n' || c == 'N')
	   {
	       ch = 4;
	       break;
	   }
       }
       delwin(w);
       touchwin(stdscr);
       refresh();
   }

   if (ch == 2) // To ask for the file name for saving
   {
       w = msgbox(8,40,9,20);
       wmove (w,1,1);
       waddstr (w,"Save As");
       wmove (w,4,1);
       waddstr (w,"File name : ");
       wrefresh(w);
       n = newwin(1,25,4+9,13+20);
       wbkgd(n,COLOR_PAIR(31));
       wattron(n,COLOR_PAIR(16));
       wmove (n,0,0);
       keypad(n,1);
       while (1)
       {
	   if (i < 25)
		c = wgetch(n);
	   else
	   {
		c = wgetch(n);
		if (c != KEY_BACKSPACE && c != '\n' && c != 27)
		{
		  beep();
		  continue;
		}
	   }
	   if (c == 27)
	   {
	       ch = 5;
	       break;
	   }
	   if (c == '\n')
	       break;
	   if (c == KEY_BACKSPACE)
	   {
	       if (i > 0)
		   i--;
	       else
	       {
			beep();
			continue;
	       }
	       wmove (n,0,i);
	       waddch(n,' ');
	       wmove (n,0,i);
	       touchwin(n);
	       wrefresh(n);
	   }
	   else
	   if ((c >= 'a' && c <= 'z') || (c >= 'A' && c <= 'Z') || (c == '.' || c == '_') || (c >= '0' && c<= '9'))
	   {
	       name[i++] = c;
	       waddch (n,c);
	   }
	   else
	       beep();
	   wrefresh(n);
       }
       delwin(n);
       delwin(w);
       touchwin(stdscr);
       refresh();
       if (c != 27)
       {
	   name[i] = '\0';
	   strcpy(fname,name);
	   ch = 3;
       }
   }

   if (ch == 3) // To save the file with the name present in the array fname
   {
       fp = fopen(fname,"w");
       if (fp)
       {
	   tl = s;
	   while (tl)
	   {
	      t = tl -> start;
	      while (t)
	      {
		   putc(t->item,fp);
		   t = t -> next;
	      }
	      putc ('\n',fp);
	      tl = tl -> down;
	   }
	   fclose(fp);
	   saved = 1;
	   dispsflag();
       }
       else
       {
	   w = newwin(3,40,9,20);
	   wbkgd(w,COLOR_PAIR(31));
	   wattron(w,COLOR_PAIR(16));
	   box (w,ACS_VLINE,ACS_HLINE);
	   wmove (w,1,1);
	   waddstr (w,"              Cannot Save");
	   wgetch(w);
	   delwin(w);
	   touchwin(stdscr);
	   refresh();
       }
   }
   display(1);
   dispnum(2);
   if (ch == 5)
       return 0;
   else
       return 1;

}

void dispsflag()
{
   int i;
   if (saved)
   {
	if (bk)
	{
	    i = textcolor + 7;
	    wattron(stdscr,COLOR_PAIR(bordercolor + 7));
	}
	else
	{
	     i = textcolor;
	     wattron(stdscr,COLOR_PAIR(bordercolor));
	}
	wmove(stdscr,22,2);
	whline(stdscr,ACS_HLINE,1);
	wattron(stdscr,COLOR_PAIR(i));
   }
   else
   {
      move(22,2);
      printw("*");
   }
   refresh();
}

void fileoption(int o)
{
   WINDOW *w,*n;
   chtype c;
   char name[30];
   int i=0;

   switch(o)
   {
	case 0:

		if (!saved)
		   if (!savefile(1))
			break;
		deletebuffer();
		strcpy (fname,"Untitled");
		saved = 0;
		wclear (textwin);
		wrefresh(textwin);
		touchwin(stdscr);
		refresh();
		break;
	case 1:
		if (!saved)
		   if (!savefile(1))
		       break;
		w = msgbox(7,40,9,20);
		wmove (w,1,1);
		waddstr (w,"Open File");
		wmove (w,4,1);
		waddstr (w,"File name :");
		wrefresh(w);
                n = newwin(1,25,13,32);
                wbkgd(n,COLOR_PAIR(31));
	        wattron(n,COLOR_PAIR(16));
                wmove (n,0,0);
		keypad(n,1);
		while (1)
		{
		    if (i < 25)
			c = wgetch(n);
		    else
		    {
			c = wgetch(n);
			if (c != KEY_BACKSPACE && c != '\n' && c != 27)
			{
				beep();
				continue;
			}
		    }
		    if (c == 27)
			break;
		    if (c == '\n')
			break;
		    if (c == KEY_BACKSPACE)
		    {
			if (i > 0)
			    i--;
			else
			{
			    beep();
			    continue;
			}
			wmove (n,0,i);
			waddch(n,' ');
			wmove (n,0,i);
			touchwin(n);
			wrefresh(n);
		    }
		    else
		    if ((c >= 'a' && c <= 'z') || (c >= 'A' && c <= 'Z') || (c == '.' || c == '_') || (c >= '0' && c<= '9'))
		    {
			name[i++] = c;
			waddch (n,c);
		    }
		    else
			beep();
		    wrefresh(n);
		}
		delwin(n);
		delwin(w);
		touchwin(stdscr);
		refresh();
		if (c != 27)
		{
		     name[i] = '\0';
		     strcpy(fname,name);
		     deletebuffer();
		     openfile();
 		     saved=1;
		     dispsflag();
		}
		display(1);
		dispnum(2);
		break;
	case 2:
		if (!saved)
		{
		    if (strcmp(fname,"Untitled") == 0)
			savefile(2);
		    else
			savefile(3);
		}
		wrefresh(textwin);
		break;
	case 3:
		savefile(2);
		break;
	case 4:
		w = msgbox (7,40,9,20);
		wmove (w,1,1);
		waddstr (w,"Delete File :");
		wmove (w,4,1);
		waddstr (w,"File Name :");
		wrefresh(w);
		n = newwin(1,25,13,19+13);
	        wbkgd(n,COLOR_PAIR(31));
	        wattron(n,COLOR_PAIR(16));
		wrefresh(n);
		wmove (n,0,0);
		keypad(n,1);
		while (1)
		{
		    if (i < 25)
			c = wgetch(n);
		    else
		    {
			c = wgetch(n);
			if (c != KEY_BACKSPACE && c != '\n' && c != 27)
			{
				beep();
				continue;
			}
		    }
		    if (c == 27)
			break;
		    if (c == '\n')
			break;
		    if (c == KEY_BACKSPACE)
		    {
			if (i > 0)
			    i--;
			else
			{
			    beep();
			    continue;
			}
			wmove (n,0,i);
			waddch(n,' ');
			wmove (n,0,i);
			touchwin(n);
			wrefresh(n);
		    }
		    else
		    if ((c >= 'a' && c <= 'z') || (c >= 'A' && c <= 'Z') || (c == '.' || c == '_') || (c >= '0' && c<= '9'))
		    {
			name[i++] = c;
			waddch (n,c);
		    }
		    else
			beep();
		    wrefresh(n);
		}
		delwin(n);
		delwin(w);
		touchwin(stdscr);
		refresh();
		if (c == 27)
		    break;

		name[i] = '\0';
		w = msgbox(8,40,9,20);
		wmove (w,1,1);
		waddstr (w,"Warning");
		if ((strcmp (name,fname) == 0))
		{
		    wmove (w,4,1);
		    waddstr (w," The file is currently open ");
		}
		wmove (w,6,1);
		waddstr (w,"Confirm delete File (Y/N): ");
		while (1)
		{
		     c = wgetch(w);
		     if (c == 27)
			 break;
		     else
		     if (c == 'y' || c == 'Y')
			 break;
		     else
		     if (c == 'n' || c == 'N')
			 break;
		     else
			 beep();	
		}
		delwin(w);
		touchwin(stdscr);
		refresh();
		if (c == 'y' || c == 'Y')
		     deletefile(name);
		if ((strcmp (name,fname) == 0))
		{
			deletebuffer();
			strcpy (fname,"Untitled");
			saved = 0;
			wclear (textwin);
			wrefresh(textwin);
			touchwin(stdscr);
			refresh();
		}
		display(1);
		dispnum(2);
		break;
	case 5:
		if (!saved)
		{
			savefile(1);
		}
		quit();
   }
   dispnum(2);
}

void setmargin()
{
    WINDOW *w;
    bool flag;
    chtype c;
    int i;
    void *p;
    char *mar[] = {" Left Margin  :",
		   " Right Margin :"};

    curs_set(0);
    w = msgbox(9,50,8,15);
    wmove (w,1,1);
    waddstr (w," MARGIN");

    wmove (w,3,1);
    wattr_on (w,A_STANDOUT,p);
    waddstr (w,mar[0]);
    wattr_off(w,A_STANDOUT,p);

    wprintw (w," %d",leftm-1);
    wmove (w,4,1);
    waddstr (w,mar[1]);
    wprintw (w," %d",(78 - rightm - 2));
    wmove (w,6,1);
    waddstr (w,"   Press i to increase and d to decrease ");
    wmove (w,7,1);
    waddstr (w," Use arrow keys to toggle and Enter to Set");
    i = 3;
    wrefresh(w);
    while (1)
    {
	c = getch();
	if (c == '\n')
	   break;
	if (c == 27)
	   break;
	switch (c)
	{
	    case KEY_UP:
			wattr_off(w,A_STANDOUT,p);
			wmove (w,i,1);
			waddstr (w,mar[i-3]);
			if (i == 3)
			     i = 4;
			else
			     i = 3;
			wattr_on(w,A_STANDOUT,p);
			wmove (w,i,1);
			waddstr (w,mar[i-3]);
			wrefresh(w);
			break;
	    case KEY_DOWN:
			wattr_off(w,A_STANDOUT,p);
			wmove (w,i,1);
			waddstr (w,mar[i-3]);
			if (i == 4)
			     i = 3;
			else
			     i = 4;
			wattr_on(w,A_STANDOUT,p);
			wmove (w,i,1);
			waddstr (w,mar[i-3]);
			wrefresh(w);
			break;
	    case 'i':
	    case 'I':
			if (i == 3)
			{
			    if ((leftm-1) < 20)
				leftm++;
			    else
			    {
				beep();
				break;
			    }
			    wmove (w,3,strlen(mar[0])+2);
			    wprintw (w,"  ");
			    wmove (w,3,strlen(mar[0])+2);
			    wprintw (w,"%d",leftm-1);
			    wrefresh(w);
			}
			else
			{
			    if ((78 - rightm - 2) < 20)
				rightm--;
			    else
			    {
				beep();
				break;
			    }
			    wmove (w,4,strlen(mar[1])+2);
			    wprintw (w,"  ");
			    wmove (w,4,strlen(mar[1])+2);
			    wprintw (w,"%d",(78 - rightm - 2));
			    wrefresh(w);
			}
			break;
	    case 'd':
	    case 'D':
			if (i == 3)
			{
			    if ((leftm - 1) > 1)
				leftm--;
			    else
			    {
				beep();
				break;
			    }
			    wmove (w,3,strlen(mar[0])+2);
			    wprintw (w,"  ");
			    wmove (w,3,strlen(mar[0])+2);
			    wprintw (w,"%d",leftm-1);
			    wrefresh(w);
			}
			else
			{
			    if ((78 - rightm - 2) > 1)
				rightm++;
			    else
			    {
				beep();
				break;
			    }
			    wmove (w,4,strlen(mar[1])+2);
			    wprintw (w,"  ");
			    wmove (w,4,strlen(mar[1])+2);
			    wprintw (w,"%d",(78 - rightm - 2));
			    wrefresh(w);
			}
			break;
	    default:
			beep();
	}
	wattr_off(w,A_STANDOUT,p);
	
    }
    curs_set(1);
    wclear(w);
    wrefresh(w);
    delwin(w);
    touchwin(stdscr);
    refresh();
    if (c == 27)
    {
        display(1);
        dispnum(2);
	return;
    }
    wclear(textwin);
    delwin(textwin);
    max = rightm - leftm + 1;
    textwin = newwin (18,max+2,4,leftm);
    if (bk)
        wbkgd(textwin,COLOR_PAIR(8));
    else
        wbkgd(textwin,COLOR_PAIR(1));
    //draw_border();
   // text_color();
   // init();
    x = 1;
    y = ytop;
    count = 1;
    lines = 1;
    topnode = s;
    curline = s;
    display(1);
    dispnum(2);
}

void search()
{
   char st[25];
   line *tl;
   bool f;
   int tc = 1,tlines = 1,i=0,tx= 1,ty;
   node *t,*p;
   WINDOW *w,*n;
   chtype c;
   void *ptr;

   if (curline == NULL)
   {
     beep();
     return;
   }

   w = msgbox(8,50,9,15);
   wmove (w,1,1);
   waddstr (w,"Search");
   wmove (w,4,1);
   waddstr (w,"Enter the search string: ");
   wrefresh(w);
   n = newwin(1,25,4+9,24+15);
   wbkgd(n,COLOR_PAIR(31));
   wattron(n,COLOR_PAIR(16));
   wmove (n,0,0);
   keypad(n,1);
   while (1)
   {
      if (i < 25)
	c = wgetch(n);
      else
      {
	c = wgetch(n);
	if (c != KEY_BACKSPACE && c != '\n' && c != 27)
	{
	  beep();
	  continue;
	}
      }
      if (c == 27)
	  break;
      if (c == '\n')
	  break;
      if (c == KEY_BACKSPACE)
      {
	  if (i > 0)
	   i--;
	  else
	  {
		beep();
		continue;
	  }
	  wmove (n,0,i);
	  waddch(n,' ');
	  wmove (n,0,i);
	  touchwin(n);
	  wrefresh(n);
      }
      else
      if ((c >= 'a' && c <= 'z') || (c >= 'A' && c <= 'Z') || (c == '.' || c == '_') || (c >= '0' && c<= '9'))
      {
	  st[i++] = c;
	  waddch (n,c);
      }
      else
	  beep();
      wrefresh(n);
   }
   if (c == 27)
   {
       delwin(n);
       delwin(w);
       touchwin(stdscr);
       refresh();
       touchwin(textwin);
       wrefresh(textwin);
       return;
   }

   st[i] = '\0';
   tl = s;
   tlines = 1;
   while (tl)
   {
       t = tl -> start;
       while (t)
       {
	   f = 0;
	   p = t;
	   if (t -> item == st[0])
	   {
	      if (strlen(st) == 1)
	      {
              	  f = 1;
	          if (t)
	               t = t -> next;
              }
	      else
	      {
		  for (i = 1;i<strlen(st);i++)
		  {
		      t = t -> next;
		      if (!t)
			  break;
		      if (st[i] != t -> item)
			  break;
		  }
		  if (i == strlen(st))
		      f = 1;
	      }
	      if (f)
	      {
		  topnode = tl;
		  curline = tl;
		  y = ytop;
		  if (tc >= max)
		  {
		      if (tc % max == 0)
			   y += tc / max - 1;
		      else
			   y += tc / max;
		  }
		  if (strlen(st) == 1)
		  {
			x = (tx % max) + 1;
			tc++;
		  }
		  else
		  {
			x = (tx + i - 1) % max + 1;
			tc += i;
		  }
		  count = tc;
		  lines = tlines + y;
		  display(1);
		  dispnum(1);
		  ty = y;

		  wattr_on (textwin,A_STANDOUT,ptr);
		  while (i)
		  {
		      wmove(textwin,ty,tx);
		      waddch (textwin,p -> item);
		      p = p -> next;
		      if (tx < max)
			 tx++;
		      else
		      {
			  ty++;
			  tx = 1;
		      }
		      i--;
		  }
		  wattr_off (textwin,A_STANDOUT,ptr);
		  if (strlen(st) != 1)
		      t = t -> next;
		  tx = x;
		  y = ty;
		  lines = tlines + y;
		  dispnum(1);
		  touchwin(stdscr);
		  wrefresh(stdscr);
		  touchwin(textwin);
		  wrefresh(textwin);

		  touchwin(w);
		  wrefresh(w);
		  touchwin(n);
		  wrefresh(n);
		  wmove (w,6,1);
		  waddstr (w," Search again (Y/N) :");
		  while (1)
		  {
		      c = wgetch(w);
		      if (c == 'n' || c == 'N' || c == 27 || c == 'Y' || c == 'y')
			  break;
		  }
		  if (c == 'n' || c == 'N' || c == 27)
		       break;
	      }
	      else
	      {
		  f = 0;
		  if (strlen(st) == 1)
		  {
			tx = tx % max + 1;
			tc++;
		  }
		  else
		  {
			tx = (tx + i - 1) % max + 1;
			tc += i;
		  }
	      }
	      i = 1;
	   }
	   else
	   {
	       tc++;
	       if (tx < max)
		    tx++;
	       else
	       if (tx % max == 0)
		    tx = 1;
	       if (t)
	               t = t -> next;
	   }
       }
       if (c == 'n' || c == 'N' || c == 27)
	   break;
       tc = 1;
       tx = 1;
       if (tl -> count % max == 0)
	    tlines += tl -> count / max;
       else
	    tlines += tl -> count / max + 1;
       tl = tl -> down;
   }
   if (c != 27 && c != 'n' && c != 'N')
   {
       wmove (w,6,1);
       waddstr (w," String not found         ");
       wrefresh(w); 
       wgetch(n);
   }
   delwin(n);
   delwin(w);
   touchwin(stdscr);
   wrefresh(stdscr);
   touchwin(textwin);
   wrefresh(textwin);
}

void filemenu()
{
   char *menu[] = {  " New     Ctrl+N ",
		     " Open        F3 ",
		     " Save        F2 ",
		     " Save As        ",
		     " Delete         ",
		     " Exit    Ctrl+X " };
   int i;

   i = movement(menu,6,18,5);

   switch(i)
   {
	case -1:
		helpmenu();
		break;
	case -2:
		editmenu();
		break;
	case 0:
		fileoption(0);
		break;
	case 1:
		fileoption(1);
		break;
	case 2:
		fileoption(2);
		break;
	case 3:
		fileoption(3);
		break;
	case 4:
		fileoption(4);
		break;
	case 5:
		fileoption(5);
		break;
   }
   wrefresh(stdscr);
   wrefresh(textwin);
}

void editmenu()
{
   char *menu[] = {  " Delete Word   Ctrl+W ",
		     " Delete Line   Ctrl+Y ",
		     " Insert Line   Ctrl+L ",
		     " Search               ",
		     " Margins              ",
		     " Word Count           "};
   int i;
   wrefresh(textwin);
   wrefresh(stdscr);

   i = movement(menu,6,24,25);
   switch(i)
   {
	case -1:
		filemenu();
		break;
	case -2:
		settings();
		break;
	case 0:
		deleteword();
		break;
	case 1:
		deleteline();
		break;
	case 2:
		insline();
		break;
	case 3:
		search();
		break;
	case 4:
		setmargin();
		break;
	case 5:
		wordcount();
		break;
     }
   wrefresh(textwin);
   wrefresh(stdscr);
}

void settings()
{
   char *menu[] = {  " Text colour ",
		     " Line colour ",
		     " Background  "};
   int i;
   wrefresh(textwin);
   wrefresh(stdscr);

   i = movement(menu,3,15,41);
   switch(i)
   {
	case -1:
		editmenu();
		break;
	case -2:
		helpmenu();
		break;
	case 0:
		textcol(0);
		break;
	case 1:
		textcol(1);
		break;
        case 2:
		textcol(2);
		break;

     }
   wrefresh(textwin);
   wrefresh(stdscr);
}

void helpmenu()
{
   char *menu[] = {  " Help     F1",
		     " About      "};
   int i;
   wrefresh(textwin);
   wrefresh(stdscr);
   
   i = movement(menu,2,14,63);
   switch(i)
   {
	case -1:
		settings();
		break;
	case -2:
		filemenu();
		break;
	case  0:
		help(3);
		break;
	case  1:
		help(2);
		break;
   }
   wrefresh(textwin);
   wrefresh(stdscr);
}
